/* Starsiege Quickchat Generator v1.0 (SQCGen)
 * See sqcgen.html for details.
 * Created by Pincushion - March 31, 1999
 */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <windows.h>

static char buf[1024];
static char ssdir[1024];
static char tail_outfn[] = "scripts\\quickchat.cs";
static char outfn[1024];

static char *msg[] = {
"Say(\"TargetTeam\",1,\"Excellent.\",\"M1_DM_excellent.WAV\");",
"Say(\"Target\",1,\"Honorless dog!\",\"M1_DM_honorlessdog.WAV\");",
"Say(\"TargetTeam\",1,\"I'm going to burn you!\",\"M1_DM_imgoingto.WAV\");",
"Say(\"TargetTeam\",1,\"See how you like this.\",\"M1_DM_seehowy.WAV\");",
"Say(\"TargetTeam\",1,\"You panic easily.\",\"M1_DM_youpanic.WAV\");",
"Say(\"TargetTeam\",1,\"You're going down!\",\"M1_DM_yourgoing.WAV\");",
"Say(\"Target\",1,\"You're insane--and dead!\",\"M1_DM_yourinsane.WAV\");",
"Say(\"Team\",1,\"Vape 'em!\",\"M1_TDM_vapem.WAV\");",
"Say(\"TargetTeam\",1,\"That shows very poor discipline.\",\"M1_DM_thatshows.WAV\");",
};
#define MAXMSG (sizeof(msg)/sizeof(msg[0]))

static void usage( char *pgm )
{
	fprintf( stderr,
"Usage: %s <sqcfile>\n", pgm );
	fprintf( stderr,
"Where <sqcfile> is a text file containing up to %d quickchats that will be\n",
		MAXMSG );
	fprintf( stderr,
"embedded in the proper formatting and written to %s.\n", outfn );
}

int main( int argc, char **argv )
{
	FILE *fp;
	char *fn, *p;
	int i, ret;

	ret = -1;
	if ( (argc < 2) || (argv[1][1]=='?') ) {
		usage( argv[0] );
		goto done;
	}

	/* Infer the Starsiege folder based on where sqcgen.exe lives */
	strcpy( ssdir, argv[0] );
	p = strrchr( ssdir, '\\' );
	if ( p == 0 ) {
where:
		fprintf( stderr, "%s: Where am I?\n", argv[0] );
		goto done;
	}
	*p = '\0';
	p = strrchr( ssdir, '\\' );
	if ( p == 0 )
		goto where;
	*p = '\0';
	sprintf( outfn, "%s\\%s", ssdir, tail_outfn );

	/* Load message file */
	fn = argv[1];
	fp = fopen( fn, "r" );
	if ( fp == 0 ) {
openerr:
		fprintf( stderr, "%s: Can't open %s.\n", argv[0], fn );
		goto done;
	}
	for ( i=0 ; i<MAXMSG ; ) {
		fgets( buf, sizeof(buf)-1, fp );
		if ( feof( fp ) )
			break;
		for ( p=buf+strlen(buf)-1 ; (p>=buf) && isspace(*p) ; p-- )
			;
		*++p = '\0';
		if ( (buf[0] == '\0') || (buf[0] == '/') || isspace(buf[0]) )
			continue;
		msg[i] = malloc( strlen(buf)+1 );
		strcpy( msg[i], buf );
		++i;
	}
	fclose( fp );

	/* Create output file */
	fn = outfn;
	fp = fopen( fn, "w" );
	if ( fp == 0 )
		goto openerr;
	fprintf( fp, "// Generated from %s by SQCGen\n", argv[1] );
	fprintf( fp, "function InitQuickChat()\n" );
	fprintf( fp, "{\n" );
	fprintf( fp, "newObject( TauntsVol, SimVolume, \"Taunts.vol\" );\n" );
	fprintf( fp, "}\n" );
	for ( i=0 ; i<MAXMSG ; i++ ) {
		fprintf( fp, "function QuickChat%d()\n", i+1 );
		fprintf( fp, "{\n" );
		fprintf( fp, "%s\n", msg[i] );
		fprintf( fp, "}\n" );
	}
	fclose( fp );

	printf( "Created %s.\n", outfn );
	ret = 0;
done:
	if ( ret < 0 ) {
		fflush( stderr );
		Sleep( 5000 );
	}
	return( ret );
}
